//+------------------------------------------------------------------+
//|                                                     C3CTurbo.mqh |
//|                                    Copyright 2017, Erwin Beckers |
//|                                              www.erwinbeckers.nl |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, Erwin Beckers"
#property link      "www.erwinbeckers.nl"
#property strict


// inputs for 3cturbo
extern string     __3cturbo               = " ------- 3CTurbo settings ------------";
extern int        Len                  = 7;
extern double     Filter               = 0.0;


//--------------------------------------------------------------------
class C3CTurbo
{
private:
   double            _3cturboYellow[];
   double            _3cturboGreen[];
   double            _3cturboRed[];

public:
   //--------------------------------------------------------------------
   C3CTurbo()
   {
      ArrayResize(_3cturboGreen , 500+5, 0);
      ArrayResize(_3cturboRed   , 500+5, 0);
      ArrayResize(_3cturboYellow, 500+5, 0);
   }
   
   //--------------------------------------------------------------------
   bool IsGreen(int bar)
   {
      if (bar <0 || bar >= 500) return false;
      return (_3cturboGreen[bar] != EMPTY_VALUE);
   }
   
   //--------------------------------------------------------------------
   double GreenValue(int bar)
   {
      if (bar <0 || bar >= 500) return EMPTY_VALUE;
      return _3cturboGreen[bar];
   }
   
   //--------------------------------------------------------------------
   double RedValue(int bar)
   {
      if (bar <0 || bar >= 500) return EMPTY_VALUE;
      return _3cturboRed[bar];
   }
   
   //--------------------------------------------------------------------
   void Refresh(string symbol)
   {
      ArrayInitialize(_3cturboYellow, 0);
      ArrayInitialize(_3cturboGreen, 0);
      ArrayInitialize(_3cturboRed, 0);
      double f88=0;
      double f90=0;
      double f0=0;
      double v4=0;
      double v8=0;
      double vC=0;
      double v10=0;
      double v14=0;
      double v18=0;
      double v20=0;
      double f8=0;
      double f10=0;
      double f18=0;
      double f20=0;
      double f28=0;
      double f30=0;
      double f38=0;
      double f48=0;
      double v1C=0;
      double f50=0;
      double f58=0;
      double f60=0;
      double f68=0;
      double f70=0;
      double f78=0;
      double f80=0; 
      double f40=0;
   
   
      int barLimit = 500 - Len - 1;
      for (int bar = barLimit; bar >= 0; bar--) 
      {
         if (f90 == 0.0) {
      
         f90 = 1.0;
         f0 = 0.0;
         if (Len-1 >= 5) f88 = Len-1.0; else f88 = 5.0;
 //      f8 = 100.0*(Close[shift]);
 // 
 //      Modified for median price
 //
         f8 = 100.0*((iHigh(symbol,0,bar)+iLow(symbol,0,bar)+iClose(symbol,0,bar))/3);
         f18 = 3.0 / (Len + 2.0);
         f20 = 1.0 - f18;
         
      } else{
         if (f88 <= f90) f90 = f88 + 1; else f90 = f90 + 1;
         f10 = f8;
 //      f8 = 100*Close[shift];
         f8 = 100.0*((iHigh(symbol,0,bar)+iLow(symbol,0,bar)+iClose(symbol,0,bar))/3);
         v8 = f8 - f10;
         f28 = f20 * f28 + f18 * v8;
         f30 = f18 * f28 + f20 * f30;
         vC = f28 * 1.5 - f30 * 0.5;
         f38 = f20 * f38 + f18 * vC;
         f40 = f18 * f38 + f20 * f40;
         v10 = f38 * 1.5 - f40 * 0.5;
         f48 = f20 * f48 + f18 * v10;
         f50 = f18 * f48 + f20 * f50;
         v14 = f48 * 1.5 - f50 * 0.5;
         f58 = f20 * f58 + f18 * MathAbs(v8);
         f60 = f18 * f58 + f20 * f60;
         v18 = f58 * 1.5 - f60 * 0.5;
         f68 = f20 * f68 + f18 * v18;

         f70 = f18 * f68 + f20 * f70;
         v1C = f68 * 1.5 - f70 * 0.5;
         f78 = f20 * f78 + f18 * v1C;
         f80 = f18 * f78 + f20 * f80;
         v20 = f78 * 1.5 - f80 * 0.5;

         if ((f88 >= f90) && (f8 != f10)) f0 = 1.0;
         if ((f88 == f90) && (f0 == 0.0)) f90 = 0.0;
      }

      if ((f88 < f90) && (v20 > 0.0000000001)) {

         v4 = (v14 / v20 + 1.0) * 50.0;
         if (v4 > 100.0) v4 = 100.0;
         if (v4 < 0.0) v4 = 0.0;

      } else {
         v4 = 50.0;
      }
      
      _3cturboYellow[bar] = v4;
      _3cturboGreen[bar]  = v4;
      _3cturboRed[bar]    = v4;
      
      
      if (_3cturboYellow[bar] > _3cturboYellow[bar+1]-Filter)
      {
          _3cturboRed[bar] = EMPTY_VALUE;
      }
      else if (_3cturboYellow[bar] < _3cturboYellow[bar+1]+Filter) 
      {
          _3cturboGreen[bar] = EMPTY_VALUE;
      }
      else if (_3cturboYellow[bar] == _3cturboYellow[bar+1]+Filter) 
      {
          _3cturboGreen[bar] = EMPTY_VALUE;
          _3cturboRed[bar] = EMPTY_VALUE;
      }
     }
   }
};